XIncludeFile "chipmunk.pbi"

Structure ballstructure
  *thisBall.cpBody
  *thisShape.cpShape
  radius.cpFloat
  ballstouching.i
  othertouching.i
EndStructure

Structure boxstructure
  *thisShape.cpShape
  dimensions.cpBB
EndStructure


ProcedureC begin(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  *balldata.ballstructure
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)

  If *firstshape\collision_type = 2 And *secondshape\collision_type =2
    ProcedureReturn 0
    ;Debug "begin"
    *balldata = *firstshape\Datum
    *balldata\ballstouching + 1
    *balldata = *secondshape\Datum
    *balldata\ballstouching + 1
  Else
    If *firstshape\collision_type = 2
      *balldata = *firstshape\Datum
      *balldata\othertouching + 1
    EndIf
    If *secondshape\collision_type = 2
      *balldata = *secondshape\Datum
      *balldata\othertouching + 1
    EndIf
  EndIf
  ProcedureReturn 1
EndProcedure

ProcedureC myteleport(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  *balldata.ballstructure
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  
  thispoint.cpVect
  ;cpv(thispoint, *firstshape\body\position\x, *firstshape\body\position\y)
  ;Debug StrD(thispoint\x) + ", " + StrD(thispoint\y)
  cpv(thispoint, Mod(*firstshape\body\position\x + 1024,1024), Mod(*firstshape\body\position\y + 768,768))
  ;Debug StrD(thispoint\x) + ", " + StrD(thispoint\y)
  cpBodySetPos(*firstshape\body, thispoint)
  ;cpArbiterGetPoint(thispoint,*arb,0)
  ;depth.cpFloat = cpArbiterGetDepth(*arb,0)
  ;Debug StrD(thispoint\x) + ", " + StrD(thispoint\y) + " ( " + StrD(depth) + " )"
  
  ProcedureReturn 0
EndProcedure



ProcedureC presolve(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  
  If *firstshape\group > 0 And *secondshape\group > 0
    ;Debug "presolve"
  EndIf
  ProcedureReturn 1
  
EndProcedure

ProcedureC postsolve(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  If *firstshape\group > 0 And *secondshape\group > 0
    ;Debug "postsolve"
  EndIf
  
EndProcedure

ProcedureC separate(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  *balldata.ballstructure
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  If *firstshape\collision_type = 2 And *secondshape\collision_type = 2
    *balldata = *firstshape\Datum
    *balldata\ballstouching - 1
    *balldata = *secondshape\Datum
    *balldata\ballstouching - 1
  Else
    If *firstshape\collision_type = 2
      *balldata = *firstshape\Datum
      *balldata\othertouching - 1
    EndIf
    If *secondshape\collision_type = 2
      *balldata = *secondshape\Datum
      *balldata\othertouching - 1
    EndIf
  EndIf
  
  
EndProcedure



Global Dim BoxList.boxstructure(0)

Procedure addbox(*space.cpSpace, *staticbody.cpBody, left.cpFloat, bottom.cpFloat, right.cpFloat, top.cpFloat, collisiontype.cpCollisionType)
  NewBox.i = ArraySize(BoxList())
  ReDim BoxList(NewBox)
  cpBBNew(BoxList(newbox)\dimensions, left, bottom, right, top)
  *thisShape.cpShape = cpSpaceAddShape(*space, cpBoxShapeNew2(*staticbody, BoxList(newbox)\dimensions))
  *thisShape\elasticity = 1.0
  *thisShape\friction = 1.0
  *thisShape\collision_type = collisiontype
  BoxList(NewBox)\thisShape = *thisShape
EndProcedure



Global Dim SegmentList.cpVect(1,0)

Procedure addsegment(*space.cpSpace, *staticbody.cpBody, startX.cpFloat, startY.cpFloat, endX.cpFloat, endY.cpFloat)
  NewSegment.i = ArraySize(SegmentList(),2) + 1
  ReDim SegmentList(1,NewSegment)
  startv.cpVect
  endv.cpVect
  *thisShape.cpSegmentShape
  
  cpv(startv, startx, starty)
  cpv(endv, endx, endy)
  
  *thisShape = cpSegmentShapeNew(*staticbody, startv, endv, 10.0)
  cpSpaceAddShape(*space, *thisShape)
  *thisShape\elasticity = 1.0
  *thisShape\friction = 1.0
  *thisShape\collision_type = 1
  
  cpv(SegmentList(0,NewSegment),startx,starty)
  cpv(SegmentList(1,NewSegment),endx, endy)
EndProcedure



Global Dim BallList.ballstructure(10000)
Global ballcount.i = 0

Procedure.i addball(*space.cpSpace, posx.cpFloat, posy.cpFloat, velx.cpFloat, vely.cpFloat, radius.cpFloat, group.i )
  ballcount + 1
  newball.i = ballcount
  
  mass = 10.0
  moment.cpFloat = cpMomentForCircle(mass, 0, radius, cpvzero)
  *ballbody.cpBody = cpSpaceAddBody(*space, cpBodyNew(mass, moment))
  position.cpVect
  cpv(position, posx, posy)
  cpBodySetPos(*ballbody, position)
  cpv(*ballbody\velocity, velx, vely)
  *ballshape.cpShape = cpSpaceAddShape(*space, cpCircleShapeNew(*ballbody, radius, cpvzero))
  *ballshape\friction = 1.0
  *ballshape\elasticity = 1.0
  *ballshape\group = group
  *ballshape\collision_type = 2
  *ballbody\v_limit = Random(300)+100
  BallList(newball)\thisBall = *ballbody
  BallList(newball)\thisShape = *ballshape
  BallList(newball)\radius = radius
  *ballbody\datum = @BallList(NewBall)
  *ballshape\Datum = @BallList(NewBall)
  ProcedureReturn *ballbody
EndProcedure


Procedure drawsegment(*vector1.cpVect, *vector2.cpVect)
  firstX = 20 + *vector1\x
  firstY = 748 - *vector1\y 
  secondX = 20 + *vector2\x 
  secondY = 748 - *vector2\y 
;  LineXY(firstX, firstY, secondX, secondY)
EndProcedure

Procedure drawball(*ballentry.ballstructure)
  xpos.d = *ballentry\thisBall\position\x
  ypos.d = 768 - *ballentry\thisBall\position\y
  If xpos => 1023 Or xpos <= 0
    ;    DrawText(100,*thisBody\* 15, StrD(xpos,0))
    ;    DrawText(200,*thisBody\datum * 15, StrD(ypos,0))
    ProcedureReturn
  EndIf
  If ypos >= 767 Or ypos <= 0
    ;    DrawText(100,*thisBody\datum * 15, StrD(xpos,0))
    ;    DrawText(200,*thisBody\datum * 15, StrD(ypos,0))
    ProcedureReturn
 EndIf
  Select (*ballentry\thisShape\group) % 3
    Case 1
      bluevalue = 255
    Case 2
      greenvalue = 255
    Default
      redvalue = 255
  EndSelect
  
;  
;  
;  
;  If *ballentry\ballstouching > 0
;    bluevalue - (40 * *ballentry\ballstouching)
;    greenvalue - (40 * *ballentry\ballstouching)
;  EndIf
;  If *ballentry\othertouching > 0
;    redvalue - 200
;    greenvalue - 200
;  EndIf
  Circle(xpos, ypos, *ballentry\radius, RGB(redvalue, greenvalue, bluevalue))
  ;Plot(xpos, ypos, RGB(redvalue, greenvalue, bluevalue))
EndProcedure


*space.cpSpace = cpSpaceNew()

*space\iterations = 10

*staticbody = *space\staticBody

;*space\sleepTimeThreshold = 1

;cpSpaceSetDefaultCollisionHandler(*space,@begin(), @presolve(), @postsolve(), @separate(), 0);


cpSpaceAddCollisionHandler(*Space, 2, 1, 0,@myteleport(),0,0,0)

;addsegment(*space, *staticbody, -20, -20, 1044, -20)
;addsegment(*space, *staticbody, -20, 788, 1044, 788)
;addsegment(*space, *staticbody, -20, -20, -20, 788)
;addsegment(*space, *staticbody, 1044, -20, 1044, 788)

Procedure surroundarea(*space.cpSpace, *staticbody.cpBody, width.cpFloat, height.cpFloat, padding.cpfloat, collisiontype.cpCollisionType)
  addbox(*space, *staticbody, -padding, -padding, 0, height+padding, collisiontype)
  addbox(*space, *staticbody, -padding, -padding, width+padding, 0, collisiontype)
  addbox(*space, *staticbody, width, -padding, width+padding, height+padding, collisiontype)
  addbox(*space, *staticbody, -padding, height, width+padding, height+padding, collisiontype)
EndProcedure


surroundarea(*space, *staticbody, 1024, 768, 100, 1)



For i = 1 To 6000
  addball( *space, Random(900), Random(700), Random(300) - 150, Random(300) - 150, 1.8, i);Random(2)+1)
Next i



;addball(*space, 0, 15, 0, 50, 10, 1)
;addball(*space, 0, 45, 0, 0, 10, 2)





OpenWindow(0,50,50,1024,768,"test")
InitSprite()
InitKeyboard()
OpenWindowedScreen(WindowID(0),0,0,1024,768,0,0,0,#PB_Screen_NoSynchronization   )


gravintensity = 20
gravintensitystep = 20




simtimestep.cpFloat = 1.0 / 120.0
graphicstimestep.cpfloat = 1.0 / 60.0
prevtime.cpFloat = 0
time.cpFloat = 0

startMS.i = ElapsedMilliseconds()
prevMS.i
currMS.i

nextsimframe.i
nextgraphicsframe.i

Repeat 
  Gosub processevents
  
  If exit
    Break
  EndIf
  
  prevMS = currMS
  currMS =  ElapsedMilliseconds() - startMS
  
  If currMS >= nextsimframe
      prevtime = time
      time = time + simtimestep
      cpSpaceStep(*space, simtimestep)
      
    nextsimframe = (time + simtimestep )* 1000
  EndIf
  
  If currMS >= nextgraphicsframe
    FlipBuffers()
    ClearScreen(0)
    
    StartDrawing(ScreenOutput())
    
    If 1
      DrawingMode(#PB_2DDrawing_Outlined)
      
      For i = 1 To ArraySize(SegmentList(),2)
        drawsegment(SegmentList(0,i),SegmentList(1,i))
      Next i
      
      For i = 1 To ballcount
        drawball(BallList(i))
      Next i
    EndIf
    
    timedifferential.cpFloat = ((simtimestep)*1000.0) / (currMS - prevMS)
    statustext.s = StrD(time*1000,0)+" : "+Str(currMS)+" ("+StrD(Int(currMS - (time * 1000))/1000.0,2)+" seconds behind) / "
    statustext = statustext + StrD(timedifferential,2) + " ;" + Str(ballcount)+ " / " + cpvstr(*space\gravity) + " ( intensity: " + Str(gravintensity) + " )"
    DrawText(0,0,statustext)
    StopDrawing()
    nextgraphicsframe = ElapsedMilliseconds() - startMS + (graphicstimestep * 1000)
  EndIf
  
  
Until exit ; time >= 3.5 Or 


Repeat
  
  ExamineKeyboard()
  
Until KeyboardPushed(#PB_Key_Escape) Or exit

End

processevents:
  
  Event = WindowEvent() 
  Select Event
    Case #PB_Event_CloseWindow
      exit = 1
  EndSelect
  
  ExamineKeyboard()
  If KeyboardPushed(#PB_Key_Escape)
    exit = 1
  EndIf
  If KeyboardReleased(#PB_Key_Right)
    cpv(*space\gravity,*space\gravity\x + gravintensity, *space\gravity\y)
  EndIf
  If KeyboardReleased(#PB_Key_Left)
    cpv(*space\gravity,*space\gravity\x - gravintensity, *space\gravity\y)
  EndIf
  
  If KeyboardReleased(#PB_Key_Up)
    cpv(*space\gravity,*space\gravity\x, *space\gravity\y + gravintensity)
  EndIf
  
  If KeyboardReleased(#PB_Key_Down)
    cpv(*space\gravity,*space\gravity\x, *space\gravity\y - gravintensity)
  EndIf
  
  If KeyboardReleased(#PB_Key_LeftBracket)
    gravintensity - gravintensitystep
  EndIf
  
  If KeyboardReleased(#PB_Key_RightBracket)
    gravintensity + gravintensitystep
  EndIf
  
  
Return

; IDE Options = PureBasic 5.00 (Windows - x86)
; CursorPosition = 256
; FirstLine = 244
; Folding = --
; EnableXP
; CurrentDirectory = C:\Users\void\Dropbox\
; CompileSourceDirectory