XIncludeFile "chipmunk.pbi"


ProcedureC begin(*arb.cpArbiter, *space.cpSpace, *datum)
  ProcedureReturn 1
EndProcedure


ProcedureC presolve(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  
  Debug *firstshape\body\position\x
  Debug *firstshape\body\position\y
  ProcedureReturn 1
  
EndProcedure

ProcedureC postsolve(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  
  Debug *firstshape\body\position\x
  Debug *firstshape\body\position\y
EndProcedure

ProcedureC separate(*arb.cpArbiter, *space.cpSpace, *datum)
  *firstshape.cpShape
  *secondshape.cpShape
  cpArbiterGetShapes(*arb, @*firstshape, @*secondshape)
  
  Debug *firstshape\body\position\x
  Debug *firstshape\body\position\y
EndProcedure



*space.cpSpace = cpSpaceNew()

*space\iterations = 10
*space\gravity\y = -100

cpSpaceSetDefaultCollisionHandler(*space,@begin(), @presolve(), @postsolve(), @separate(), 0)

Procedure addsegment(*space.cpSpace, *staticbody.cpBody, startX.cpFloat, startY.cpFloat, endX.cpFloat, endY.cpFloat)
;  NewSegment.i = ArraySize(SegmentList(),2) + 1
;  ReDim SegmentList(1,NewSegment)
  startv.cpVect
  endv.cpVect
  *thisShape.cpSegmentShape
  
  cpv(startv, startx, starty)
  cpv(endv, endx, endy)
  
  *thisShape = cpSegmentShapeNew(*staticbody, startv, endv, 0.0)
  cpSpaceAddShape(*space, *thisShape)
  *thisShape\elasticity = 1.0
  *thisShape\friction = 1.0
  *thisShape\layers = 1
  
;  cpv(SegmentList(0,NewSegment),startx,starty)
;  cpv(SegmentList(1,NewSegment),endx, endy)
  ProcedureReturn *thisShape
EndProcedure



;firstbound.cpVect
;secondbound.cpVect
;cpv(firstbound,-20, 15)
;cpv(secondbound,100, -25)

;*ground.cpShape = cpSegmentShapeNew(*space\staticBody, firstbound, secondbound, 0)
;*ground\friction = 1.0
;*ground\elasticity = 1.0
;cpSpaceAddShape(*space, *ground)

addsegment(*space, *space\staticBody, -20, 15, 100, -25)


;thirdbound.cpVect
;fourthbound.cpVect
;cpv(thirdbound,100, -25)
;cpv(fourthbound,180, 5)

;*ground2.cpShape = cpSegmentShapeNew(*space\staticBody, thirdbound, fourthbound, 0)
;*ground2\friction = 1.0
;*ground2\elasticity = 1.0
;cpSpaceAddShape(*space, *ground2)

addsegment(*space, *space\staticBody, 100, -25, 180, 5)



;Procedure.i addball(*space.cpSpace, *position.cpVect, mass.cpFloat , radius.cpFloat, group.i )
  
;  moment.cpFloat = cpMomentForCircle(mass, 0, radius, cpvzero)
;  *ballbody.cpBody = cpSpaceAddBody(*space, cpBodyNew(mass, moment))
;  cpv(*ballbody\position,*position\x,*position\y)
;  *ballshape.cpShape = cpSpaceAddShape(*space, cpCircleShapeNew(*ballbody, radius, cpvzero))
;  *ballshape\friction = 0.7
;  *ballshape\elasticity = 0.5
;  *ballshape\group = group
;  *ballshape\collision_type = 2
;  ProcedureReturn *ballbody
;EndProcedure

Procedure.i addball(*space.cpSpace, posx.cpFloat, posy.cpFloat, velx.cpFloat, vely.cpFloat, radius.cpFloat, group.i )
;  newball.i = ArraySize(*BallList()) + 1
;  ReDim *BallList(newball)
  
  mass = 10.0
  moment.cpFloat = cpMomentForCircle(mass, 0, radius, cpvzero)
  *ballbody.cpBody = cpSpaceAddBody(*space, cpBodyNew(mass, moment))
  cpv(*ballbody\position,posx,posy)
  cpv(*ballbody\velocity, velx, vely)
  *ballshape.cpShape = cpSpaceAddShape(*space, cpCircleShapeNew(*ballbody, radius, cpvzero))
  *ballshape\friction = 0.7
  *ballshape\elasticity = 0.5
  
;  *ballbody\data = group
;  *BallList(newball) = *ballbody
  *ballshape\collision_type = 2

  ProcedureReturn *ballbody
EndProcedure

radius.cpFloat = 5
mass.cpFloat

position.cpVect
cpv(position, 0, 15)
mass = 1.0


Dim *balllist.cpbody(10)
ballcount = 2

For i = 1 To ballcount
  cpv(position, 0, 15 * (i +1))
  *balllist(i) = addball(*space, 0, 15 * (i + 1), 0, 0, radius, i)
;  Debug *balllist(i)
Next i


timestep.cpFloat = 1.0 / 60.0
time.cpFloat = 0

OpenWindow(0,50,50,640,480,"test")
InitSprite()
InitKeyboard()
OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0)


Procedure scaleline(*vector1.cpVect, *vector2.cpVect)
  firstX = (*vector1\x * 2) + 50
  firstY = 50 -(*vector1\y * 2) 
  secondX = (*vector2\x * 2) + 50
  secondY = 50 -(*vector2\y * 2) 
  LineXY(firstX, firstY, secondX, secondY)
EndProcedure


Procedure drawball(*vector.cpVect)
  xpos.i = (*vector\x * 2)+ 50
  ypos.i = 50 - (*vector\y * 2)
  If xpos => 639 Or xpos <= 0
    ProcedureReturn
  EndIf
  If ypos >= 479 Or ypos <= 0
    ProcedureReturn
  EndIf
  Circle(xpos, ypos, 10)
EndProcedure


Repeat 
  time = time + timestep
;  Debug time
  FlipBuffers()
  ClearScreen(0)
  
  
  StartDrawing(ScreenOutput())
  ;drawball(*ballbody\position)
  For i = 1 To ballcount
    drawball(*balllist(i)\position)
  Next i
  
  ;scaleline(firstbound, secondbound)
  ;scaleline(thirdbound, fourthbound)
  
  StopDrawing()
  
  
  cpSpaceStep(*space, timestep)
  Delay(1000 * timestep)
  
  ExamineKeyboard()
  If KeyboardPushed(#PB_Key_Escape)
    exit = 1
  EndIf
  Until exit ; time >= 3.5 Or 
  
  Delay(250)
  
Repeat
  
  ExamineKeyboard()
  
  Until KeyboardPushed(#PB_Key_Escape) Or exit
  
  
cpShapeFree(*ballshape)
cpBodyFree(*ballbody)
cpShapeFree(*ground)
cpSpaceFree(*space)

; IDE Options = PureBasic 5.00 Beta 3 (Windows - x86)
; CursorPosition = 122
; FirstLine = 93
; Folding = --
; EnableXP
; UseMainFile = cptest.pb
; CurrentDirectory = C:\Users\void\Dropbox\chipmunk
; CompileSourceDirectory